<?php

namespace SuperRhino\Utils\Counter;

interface CounterInterface {

    /**
     * 计数器是否存在
     */
    public function existsRow(string $name, string $key): bool;

    /**
     * 计数器列是否存在
     */
    public function existsColumn(string $name, string $key, string $column): bool;

    /**
     * 获取计数器行
     * $counter->setCountRow('name', 'key', ['column' => 'value']);
     */
    public function setRow(string $name, string $key, array $row): bool;

    /**
     * 设置计数器列
     * $NX = true, 只在column不存在时创建
     */
    public function setColumn(string $name, string $key, string $column, int $count, bool $NX = false): bool;

    /**
     * 获取计数器行
     * // Output:
     * // array(4) {
     * //   ["a"]=>
     * //   string(1) "1"
     * //   ["b"]=>
     * //   string(1) "2"
     * // }
     */
    public function getRow(string $name, string $key): array;

    /**
     * 获取计数器列
     */
    public function getColumn(string $name, string $key, string $column): int;

    /**
     * 增加计数器列
     */
    public function increment(string $name, string $key, string $column, int $increment = 1): int;

    /**
     * 删除计数器行
     */
    public function resetRow(string $name, string $key): bool;

    /**
     * 删除计数器列
     */
    public function resetColumn(string $name, string $key, string $column): bool;

}